



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>zookeeper选举代码分析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">zookeeper选举代码分析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-25 14:32:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文将以zookeeper的3.4.6版本作为源码分析版本。主要的代码类包括QuorumPeerMain、QuorumPeer、FastLeaderElection、QuorumMaj等。</p>
<p>假设有a,b,c三个zookeeper服务，serverid分别是1、2、3：</p>
<p>1.先启动集群中的a服务，先投票自己a为leader，并将投票信息发送给自己;</p>
<p>QuorumPeerMain对象调用QuorumPeer线程的startLeaderElection方法，最终调用FastLeaderElection的lookForLeader方法</p>
<p>2.再启动集群中的b服务，先投票自己b为leader，并将投票信息发送给自己和a服务；</p>
<p>3.a收到b的投票信息，服务a通过对比算法，选择b为leader，并通知自己和服务b;</p>
<div>
<pre class="prettyprint linenums">    protected boolean totalOrderPredicate(long newId, long newZxid, long newEpoch, long curId, long curZxid, long curEpoch) {<br />
        LOG.debug("id: " + newId + ", proposed id: " + curId + ", zxid: 0x" +<br />
                Long.toHexString(newZxid) + ", proposed zxid: 0x" + Long.toHexString(curZxid));<br />
        if(self.getQuorumVerifier().getWeight(newId) == 0){<br />
            return false;<br />
        }

        /*<br />
         * We return true if one of the following three cases hold:<br />
         * 1- New epoch is higher<br />
         * 2- New epoch is the same as current epoch, but new zxid is higher<br />
         * 3- New epoch is the same as current epoch, new zxid is the same<br />
         *  as current zxid, but server id is higher.<br />
         */

        return ((newEpoch &gt; curEpoch) ||<br />
                ((newEpoch == curEpoch) &amp;&amp;<br />
                ((newZxid &gt; curZxid) || ((newZxid == curZxid) &amp;&amp; (newId &gt; curId)))));<br />
    }</pre>
</div>
<p>4.服务a通过验证算法，确认b为leader;</p>
<p>5.服务b收到a的通知信息，通过验证算法b确认自身为leader；</p>
<div>
<pre class="prettyprint linenums">    protected boolean termPredicate(<br />
            HashMap&lt;Long, Vote&gt; votes,<br />
            Vote vote) {

        HashSet&lt;Long&gt; set = new HashSet&lt;Long&gt;();

        /*<br />
         * First make the views consistent. Sometimes peers will have<br />
         * different zxids for a server depending on timing.<br />
         */<br />
        for (Map.Entry&lt;Long,Vote&gt; entry : votes.entrySet()) {<br />
            if (vote.equals(entry.getValue())){<br />
                set.add(entry.getKey());<br />
            }<br />
        }

        return self.getQuorumVerifier().containsQuorum(set);<br />
    }

public boolean containsQuorum(HashSet&lt;Long&gt; set){<br />
        return (set.size() &gt; half);<br />
    }
</pre>
</div>
<p>6.服务c启动后，发现集群已经选出leader为服务b;</p>
<p>7.下面的代码是选举过程中最重要的代码：</p>
<div>
<pre class="prettyprint linenums">    public Vote lookForLeader() throws InterruptedException {<br />
        try {<br />
            self.jmxLeaderElectionBean = new LeaderElectionBean();<br />
            MBeanRegistry.getInstance().register(<br />
                    self.jmxLeaderElectionBean, self.jmxLocalPeerBean);<br />
        } catch (Exception e) {<br />
            LOG.warn("Failed to register with JMX", e);<br />
            self.jmxLeaderElectionBean = null;<br />
        }<br />
        if (self.start_fle == 0) {<br />
           self.start_fle = System.currentTimeMillis();<br />
        }<br />
        try {<br />
            HashMap&lt;Long, Vote&gt; recvset = new HashMap&lt;Long, Vote&gt;();

            HashMap&lt;Long, Vote&gt; outofelection = new HashMap&lt;Long, Vote&gt;();

            int notTimeout = finalizeWait;

            synchronized(this){<br />
                logicalclock++;<br />
                updateProposal(getInitId(), getInitLastLoggedZxid(), getPeerEpoch());<br />
            }

            LOG.info("New election. My id =  " + self.getId() +<br />
                    ", proposed zxid=0x" + Long.toHexString(proposedZxid));<br />
            sendNotifications();

            /*<br />
             * Loop in which we exchange notifications until we find a leader<br />
             */

            while ((self.getPeerState() == ServerState.LOOKING) &amp;&amp;<br />
                    (!stop)){<br />
                /*<br />
                 * Remove next notification from queue, times out after 2 times<br />
                 * the termination time<br />
                 */<br />
                Notification n = recvqueue.poll(notTimeout,<br />
                        TimeUnit.MILLISECONDS);

                /*<br />
                 * Sends more notifications if haven't received enough.<br />
                 * Otherwise processes new notification.<br />
                 */<br />
                if(n == null){<br />
                    if(manager.haveDelivered()){<br />
                        sendNotifications();<br />
                    } else {<br />
                        manager.connectAll();<br />
                    }

                    /*<br />
                     * Exponential backoff<br />
                     */<br />
                    int tmpTimeOut = notTimeout*2;<br />
                    notTimeout = (tmpTimeOut &lt; maxNotificationInterval?<br />
                            tmpTimeOut : maxNotificationInterval);<br />
                    LOG.info("Notification time out: " + notTimeout);<br />
                }<br />
                else if(self.getVotingView().containsKey(n.sid)) {<br />
                    /*<br />
                     * Only proceed if the vote comes from a replica in the<br />
                     * voting view.<br />
                     */<br />
                    switch (n.state) {<br />
                    case LOOKING:<br />
                        System.out.println("receive message : electionEpoch,logicalclock"+n.electionEpoch+":"+logicalclock);<br />
                        // If notification &gt; current, replace and send messages out<br />
                        if (n.electionEpoch &gt; logicalclock) {<br />
                            logicalclock = n.electionEpoch;<br />
                            recvset.clear();<br />
                            if(totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,<br />
                                    getInitId(), getInitLastLoggedZxid(), getPeerEpoch())) {<br />
                                updateProposal(n.leader, n.zxid, n.peerEpoch);<br />
                            } else {<br />
                                updateProposal(getInitId(),<br />
                                        getInitLastLoggedZxid(),<br />
                                        getPeerEpoch());<br />
                            }<br />
                            sendNotifications();<br />
                        } else if (n.electionEpoch &lt; logicalclock) {<br />
                            if(LOG.isDebugEnabled()){<br />
                                LOG.debug("Notification election epoch is smaller than logicalclock. n.electionEpoch = 0x"<br />
                                        + Long.toHexString(n.electionEpoch)<br />
                                        + ", logicalclock=0x" + Long.toHexString(logicalclock));<br />
                            }<br />
                            break;<br />
                        } else if (totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,<br />
                                proposedLeader, proposedZxid, proposedEpoch)) {<br />
                            updateProposal(n.leader, n.zxid, n.peerEpoch);<br />
                            sendNotifications();<br />
                        }

                        if(LOG.isDebugEnabled()){<br />
                            LOG.debug("Adding vote: from=" + n.sid +<br />
                                    ", proposed leader=" + n.leader +<br />
                                    ", proposed zxid=0x" + Long.toHexString(n.zxid) +<br />
                                    ", proposed election epoch=0x" + Long.toHexString(n.electionEpoch));<br />
                        }

                        recvset.put(n.sid, new Vote(n.leader, n.zxid, n.electionEpoch, n.peerEpoch));

                        if (termPredicate(recvset,<br />
                                new Vote(proposedLeader, proposedZxid,<br />
                                        logicalclock, proposedEpoch))) {

                            // Verify if there is any change in the proposed leader<br />
                            while((n = recvqueue.poll(finalizeWait,<br />
                                    TimeUnit.MILLISECONDS)) != null){<br />
                                if(totalOrderPredicate(n.leader, n.zxid, n.peerEpoch,<br />
                                        proposedLeader, proposedZxid, proposedEpoch)){<br />
                                    recvqueue.put(n);<br />
                                    break;<br />
                                }<br />
                            }

                            /*<br />
                             * This predicate is true once we don't read any new<br />
                             * relevant message from the reception queue<br />
                             */<br />
                            if (n == null) {<br />
                                self.setPeerState((proposedLeader == self.getId()) ?<br />
                                        ServerState.LEADING: learningState());

                                Vote endVote = new Vote(proposedLeader,<br />
                                                        proposedZxid,<br />
                                                        logicalclock,<br />
                                                        proposedEpoch);<br />
                                leaveInstance(endVote);<br />
                                return endVote;<br />
                            }<br />
                        }<br />
                        break;<br />
                    case OBSERVING:<br />
                        LOG.debug("Notification from observer: " + n.sid);<br />
                        break;<br />
                    case FOLLOWING:<br />
                    case LEADING:<br />
                        /*<br />
                         * Consider all notifications from the same epoch<br />
                         * together.<br />
                         */<br />
                        if(n.electionEpoch == logicalclock){<br />
                            recvset.put(n.sid, new Vote(n.leader,<br />
                                                          n.zxid,<br />
                                                          n.electionEpoch,<br />
                                                          n.peerEpoch));

                            if(ooePredicate(recvset, outofelection, n)) {<br />
                                self.setPeerState((n.leader == self.getId()) ?<br />
                                        ServerState.LEADING: learningState());

                                Vote endVote = new Vote(n.leader,<br />
                                        n.zxid,<br />
                                        n.electionEpoch,<br />
                                        n.peerEpoch);<br />
                                leaveInstance(endVote);<br />
                                return endVote;<br />
                            }<br />
                        }

                        /*<br />
                         * Before joining an established ensemble, verify<br />
                         * a majority is following the same leader.<br />
                         */<br />
                        outofelection.put(n.sid, new Vote(n.version,<br />
                                                            n.leader,<br />
                                                            n.zxid,<br />
                                                            n.electionEpoch,<br />
                                                            n.peerEpoch,<br />
                                                            n.state));

                        if(ooePredicate(outofelection, outofelection, n)) {<br />
                            synchronized(this){<br />
                                logicalclock = n.electionEpoch;<br />
                                self.setPeerState((n.leader == self.getId()) ?<br />
                                        ServerState.LEADING: learningState());<br />
                            }<br />
                            Vote endVote = new Vote(n.leader,<br />
                                                    n.zxid,<br />
                                                    n.electionEpoch,<br />
                                                    n.peerEpoch);<br />
                            leaveInstance(endVote);<br />
                            return endVote;<br />
                        }<br />
                        break;<br />
                    default:<br />
                        LOG.warn("Notification state unrecognized: {} (n.state), {} (n.sid)",<br />
                                n.state, n.sid);<br />
                        break;<br />
                    }<br />
                } else {<br />
                    LOG.warn("Ignoring notification from non-cluster member " + n.sid);<br />
                }<br />
            }<br />
            return null;<br />
        } finally {<br />
            try {<br />
                if(self.jmxLeaderElectionBean != null){<br />
                    MBeanRegistry.getInstance().unregister(<br />
                            self.jmxLeaderElectionBean);<br />
                }<br />
            } catch (Exception e) {<br />
                LOG.warn("Failed to unregister with JMX", e);<br />
            }<br />
            self.jmxLeaderElectionBean = null;<br />
        }<br />
    }
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvn14z9.html">搭建企业内部yum仓库&lpar;centos6&plus;centos7&plus;epel源&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpm21q.html">React版本修改内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx3vdjq.html">&lpar;转&rpar; Active Record</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvdp71q.html">&lbrack;转载&rsqb;破解TexturePacker加密资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xwor08.html">Java中boolean型变量的默认值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e17ooe9.html">HttpHandler与HttpModule及实现文件下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm61vz9.html">BigInteger Uva</a>
		</li>
						<li><a href="https://www.batexi.com/a/96on1v39.html">phpexcel 一些基本的设置 &lpar;表格的基本属性）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv112kzq.html">PHP --字符串编码转换（自动识别原编码）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjw2gr8.html">windows 快捷方式&lpar;&period;lnk&rpar;代码执行漏洞&lpar;CVE-2017-8464 &rpar;&lbrack;附EXP生成工具&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk6w6e8.html">【Linux】系统版本信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7lzz8.html">sql server 生成数据库字典  sql语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgoz578.html">使用serialize时多数据传递</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1nnnw9.html">grovvy生成随机汉字名字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4wkmm9.html">python报错之OSError</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rxvy48.html">Get Started with the Google Fonts API</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllyxd6q.html">Django工程搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2kw2j8.html">C&num;、Java、Javascript获取Unix时间戳</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlyjw39.html">SaltStack生产案例-服务部署（redis，mysql，apache&plus;php，haproxy&plus;keepalived）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kppwoq.html">第99天：CSS3中透视perspective</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qyd3zr2q.html">给表格设置border还可以这样玩</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zx1j69.html">c&plus;&plus;primerplus&lpar;第六版&rpar;编程题&amp;mdash&semi;&amp;mdash&semi;第6章（分支语句和逻辑运算符）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okrzlp9.html">centos6&period;5安装vsftp服务并配置虚拟账户ftp</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x1ekg9.html">Java学习----一个对象怎么调用另一个对象呢？</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvw6ojq.html">Linux mail 命令使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z17d0d9.html">代码bug</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x163z8.html">JS自执行函数的几种写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj5z1k9.html">POJ1007-DNA Sorting-ACM</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxng0ez8.html">Swiper的简单实用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vxmo38.html">BZOJ 3240 矩阵游戏</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
